SRSDataAnalyzer/Models/ErrorViewModel.cs
using System;

namespace SRSDataAnalyzer.Models
{
	public class ErrorViewModel
	{
		public string RequestId { get; set; }

		public bool ShowRequestId => !string.IsNullOrEmpty(RequestId);
	}
}

SRSDataAnalyzer/Models/RaceProgression/Index.cs
namespace SRSDataAnalyzer.Models.RaceProgression
{
	public class Index
	{
		public string RaceResultsText { get; set; }
	}
}

SRSDataAnalyzer/Models/RaceProgression/RaceProgressionModel.cs
using SRSDataAnalyzer.Data;

namespace SRSDataAnalyzer.Models.RaceProgression
{
	public class RaceProgressionModel
	{
		public SRSDataAnalyzer.Data.RaceProgression Data { get; set; } = new SRSDataAnalyzer.Data.RaceProgression();
	}
}

SRSDataAnalyzer/Controllers/HomeController.cs
using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using SRSDataAnalyzer.Models;

namespace SRSDataAnalyzer.Controllers
{
	public class HomeController : Controller
	{
		public IActionResult Index()
		{
			return View();
		}

		public IActionResult About()
		{
			ViewData["Message"] = "Your application description page.";

			return View();
		}

		public IActionResult Contact()
		{
			ViewData["Message"] = "Your contact page.";

			return View();
		}

		public IActionResult Privacy()
		{
			return View();
		}

		[ResponseCache(Duration = 0, Location = ResponseCacheLocation.None, NoStore = true)]
		public IActionResult Error()
		{
			return View(new ErrorViewModel { RequestId = Activity.Current?.Id ?? HttpContext.TraceIdentifier });
		}
	}
}

SRSDataAnalyzer/Controllers/RaceProgressionController.cs
using Microsoft.AspNetCore.Mvc;
using SRSDataAnalyzer.Data;
using SRSDataAnalyzer.Models.RaceProgression;
using System.Linq;
using System.Threading.Tasks;

namespace SRSDataAnalyzer.Controllers
{
	public class RaceProgressionController : Controller
	{
		private readonly DataContext m_dataContext = null;

		public RaceProgressionController(DataContext i_dataContext)
		{
			m_dataContext = i_dataContext;
		}

		[HttpGet]
		public IActionResult Index()
		{
			return View();
		}

		[HttpPost]
		public async Task<IActionResult> AnalyzeRaceFromText(Index formInput)
		{
			if (formInput.RaceResultsText != null)
			{
				RaceProgression raceProgression = new RaceProgression();

				raceProgression.DriverRaceResults.Add(new DriverRaceResult() { Position = 1, DriverName = "Test 1", Points = 100, Incidents = 10 });
				raceProgression.DriverRaceResults.Add(new DriverRaceResult() { Position = 2, DriverName = "Test 2", Points = 90, Incidents = 1 });

				m_dataContext.Add(raceProgression);
				await m_dataContext.SaveChangesAsync();

				return RedirectToAction(nameof(ShowRaceProgression), new { id = raceProgression.ID });
			}

			return BadRequest();
		}

		[HttpGet]
		public IActionResult ShowRaceProgression(string id)
		{
			RaceProgressionModel model = new RaceProgressionModel()
			{
				Data = m_dataContext.RaceProgressions.SingleOrDefault(rp => rp.ID == id),
			};
			return View("RaceAnalysis", model);
		}
	}
}

SRSDataAnalyzer/Views/Home/About.cshtml
@section Title{ About }
<h2>About</h2>
<h3>@ViewData["Message"]</h3>

<p>Use this area to provide additional information.</p>

SRSDataAnalyzer/Views/Home/Contact.cshtml
@section Title{ Contact }
<h2>Contact</h2>
<h3>@ViewData["Message"]</h3>

<address>
</address>

<address>
</address>

SRSDataAnalyzer/Views/Home/Index.cshtml
@section Title{ Home Page }

SRSDataAnalyzer/Views/RaceProgression/Index.cshtml
@model SRSDataAnalyzer.Models.RaceProgression.Index
@section Title { Race Progression }

<h1>Race Progression</h1>

<h2>Load from URL</h2>
<form asp-action="@nameof(RaceProgressionController.AnalyzeRaceFromText)" method="post">
	<label>Copy and paste the whole text of the Race Results page</label>
	<textarea asp-for="@Model.RaceResultsText"></textarea>
	<button>Analyze results</button>
</form>

SRSDataAnalyzer/Views/RaceProgression/RaceAnalysis.cshtml
@model RaceProgressionModel
@using SRSDataAnalyzer.Data
@section Title { Race analysis - Race Progression }

<h1>Race analysis</h1>

<h2>Results summary</h2>
@foreach (DriverRaceResult driverResult in Model.Data.DriverRaceResults)
{
	<tr>
		<td>@driverResult.Position</td>
		<td>@driverResult.DriverName</td>
		<td>@driverResult.Points</td>
		<td>@driverResult.Incidents</td>
		<td>@driverResult.TotalPoints</td>
	</tr>
}

SRSDataAnalyzer/Views/Shared/_Layout.cshtml
<!DOCTYPE html>
<html>
<head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>@(await RenderSectionAsync("Title")) - SRS Data Analyzer</title>

    <environment include="Development">
        <link rel="stylesheet" href="~/lib/bootstrap/dist/css/bootstrap.css" />
        <link rel="stylesheet" href="~/css/site.css" />
    </environment>
    <environment exclude="Development">
        <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/3.4.1/css/bootstrap.min.css"
              asp-fallback-href="~/lib/bootstrap/dist/css/bootstrap.min.css"
              asp-fallback-test-class="sr-only" asp-fallback-test-property="position" asp-fallback-test-value="absolute" />
        <link rel="stylesheet" href="~/css/site.min.css" asp-append-version="true" />
    </environment>
</head>
<body>
    <nav class="navbar navbar-inverse navbar-fixed-top">
        <div class="container">
            <div class="navbar-header">
                <button type="button" class="navbar-toggle" data-toggle="collapse" data-target=".navbar-collapse">
                    <span class="sr-only">Toggle navigation</span>
                    <span class="icon-bar"></span>
                    <span class="icon-bar"></span>
                    <span class="icon-bar"></span>
                </button>
                <a asp-area="" asp-controller="Home" asp-action="Index" class="navbar-brand">SRS Data Analyzer</a>
            </div>
            <div class="navbar-collapse collapse">
                <ul class="nav navbar-nav">
                    <li><a asp-area="" asp-controller="Home" asp-action="Index">Home</a></li>
                    <li><a asp-area="" asp-controller="RaceProgression" asp-action="Index">Race progression</a></li>
                    <li><a asp-area="" asp-controller="Home" asp-action="About">About</a></li>
                    <li><a asp-area="" asp-controller="Home" asp-action="Contact">Contact</a></li>
                </ul>
            </div>
        </div>
    </nav>

    <partial name="_CookieConsentPartial" />

    <div class="container body-content">
        @RenderBody()
        <hr />
        <footer>
            <p>&copy; 2020 - SRSDataAnalyzer</p>
        </footer>
    </div>

    <environment include="Development">
        <script src="~/lib/jquery/dist/jquery.js"></script>
        <script src="~/lib/bootstrap/dist/js/bootstrap.js"></script>
        <script src="~/js/site.js" asp-append-version="true"></script>
    </environment>
    <environment exclude="Development">
        <script src="https://ajax.aspnetcdn.com/ajax/jquery/jquery-3.3.1.min.js"
                asp-fallback-src="~/lib/jquery/dist/jquery.min.js"
                asp-fallback-test="window.jQuery"
                crossorigin="anonymous"
                integrity="sha384-tsQFqpEReu7ZLhBV2VZlAu7zcOV+rXbYlF2cqB8txI/8aZajjp4Bqd+V6D5IgvKT">
        </script>
        <script src="https://stackpath.bootstrapcdn.com/bootstrap/3.4.1/js/bootstrap.min.js"
                asp-fallback-src="~/lib/bootstrap/dist/js/bootstrap.min.js"
                asp-fallback-test="window.jQuery && window.jQuery.fn && window.jQuery.fn.modal"
                crossorigin="anonymous"
                integrity="sha384-aJ21OjlMXNL5UyIl/XNwTMqvzeRMZH2w8c5cRVpzpU8Y5bApTppSuUkhZXN0VxHd">
        </script>
        <script src="~/js/site.min.js" asp-append-version="true"></script>
    </environment>

    @RenderSection("Scripts", required: false)
</body>
</html>